using System;
using System.Data.Services.Client;
using System.ComponentModel;
using SLClient.OrdersData;

namespace SLClient {
  public class DataSource : INotifyPropertyChanged {
    public DataSource( ) {
      var ordersService = new OrdersData.Orders(new Uri("http://localhost/ODataService/Orders.svc/"));

      Products = new DataServiceCollection<Product>( );
      Products.LoadCompleted += (s, e) => {
        OnPropertyChanged("Products");
      };

      Products.LoadAsync(ordersService.Product);
    }

    public DataServiceCollection<Product> Products { get; private set; }

    private Product selectedProduct;
    public Product SelectedProduct {
      get { return selectedProduct; }
      set {
        if (selectedProduct == value)
          return;
        selectedProduct = value;
        OnPropertyChanged("SelectedProduct");

        if (selectedProduct != null)
          selectedProduct.OrderLines.LoadAsync( );
      }
    }
    

    public event PropertyChangedEventHandler PropertyChanged;

    protected virtual void OnPropertyChanged(string propertyName) {
      if (PropertyChanged != null)
        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
    }
  }
}
