﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevExpress.Xpo.DB;

using Sturm.XPOUtilities.Contracts;

namespace Sturm.XPOUtilities.Client {
  public class DataStoreProxy : IDataStore {
    public DataStoreProxy(IDataStoreContract wrappedContract) {
      this.WrappedContract = wrappedContract;
    }

    public IDataStoreContract WrappedContract {get; private set;}

    #region IDataStore Members

    AutoCreateOption IDataStore.AutoCreateOption {
      get { return WrappedContract.GetAutoCreateOption( ); }
    }

    ModificationResult IDataStore.ModifyData(params ModificationStatement[] dmlStatements) {
      return WrappedContract.ModifyData(dmlStatements);
    }

    SelectedData IDataStore.SelectData(params SelectStatement[] selects) {
      return WrappedContract.SelectData(selects);
    }

    UpdateSchemaResult IDataStore.UpdateSchema(bool dontCreateIfFirstTableNotExist, params DBTable[] tables) {
      return WrappedContract.UpdateSchema(dontCreateIfFirstTableNotExist, tables);
    }

    #endregion
  }
}